diff --git a/usr.sbin/hcsecd/hcsecd.c b/usr.sbin/hcsecd/hcsecd.c
new file mode 100644
index 0000000000..2835b4a531
--- /dev/null
+++ b/usr.sbin/hcsecd/hcsecd.c
@@ -0,0 +1,446 @@
+/*
+ * hcsecd.c
+ *
+ * Copyright (c) 2001-2002 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: hcsecd.c,v 1.6 2003/08/18 19:19:55 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/hcsecd/hcsecd.c 188130 2009-02-04 22:04:06Z emax $
+ */
+
+#include <sys/queue.h>
+#include <bluetooth.h>
+#include <err.h>
+#include <errno.h>
+#include <signal.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include "hcsecd.h"
+
+static int	done = 0;
+
+static int process_pin_code_request_event
+	(int sock, struct sockaddr_hci *addr, bdaddr_p bdaddr);
+static int process_link_key_request_event
+	(int sock, struct sockaddr_hci *addr, bdaddr_p bdaddr);
+static int send_pin_code_reply
+	(int sock, struct sockaddr_hci *addr, bdaddr_p bdaddr, char const *pin);
+static int send_link_key_reply
+	(int sock, struct sockaddr_hci *addr, bdaddr_p bdaddr, uint8_t *key);
+static int process_link_key_notification_event
+	(int sock, struct sockaddr_hci *addr, ng_hci_link_key_notification_ep *ep);
+static void sighup
+	(int s);
+static void sigint
+	(int s);
+static void usage
+	(void);
+
+/* Main */
+int
+main(int argc, char *argv[])
+{
+	int					 n, detach, sock;
+	socklen_t				 size;
+	struct sigaction			 sa;
+	struct sockaddr_hci			 addr;
+	struct ng_btsocket_hci_raw_filter	 filter;
+	char					 buffer[HCSECD_BUFFER_SIZE];
+	ng_hci_event_pkt_t			*event = NULL;
+
+	detach = 1;
+
+	while ((n = getopt(argc, argv, "df:h")) != -1) {
+		switch (n) {
+		case 'd':
+			detach = 0;
+			break;
+
+		case 'f':
+			config_file = optarg;
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	if (config_file == NULL)
+		usage();
+		/* NOT REACHED */
+
+	if (getuid() != 0)
+		errx(1, "** ERROR: You should run %s as privileged user!",
+			HCSECD_IDENT);
+
+	/* Set signal handlers */
+	memset(&sa, 0, sizeof(sa));
+	sa.sa_handler = sigint;
+	sa.sa_flags = SA_NOCLDWAIT;
+	if (sigaction(SIGINT, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGINT)");
+	if (sigaction(SIGTERM, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGINT)");
+
+	memset(&sa, 0, sizeof(sa));
+	sa.sa_handler = sighup;
+	if (sigaction(SIGHUP, &sa, NULL) < 0)
+		err(1, "Could not sigaction(SIGHUP)");
+
+	/* Open socket and set filter */
+	sock = socket(PF_BLUETOOTH, SOCK_RAW, BLUETOOTH_PROTO_HCI);
+	if (sock < 0)
+		err(1, "Could not create HCI socket");
+
+	memset(&filter, 0, sizeof(filter));
+	bit_set(filter.event_mask, NG_HCI_EVENT_PIN_CODE_REQ - 1);
+	bit_set(filter.event_mask, NG_HCI_EVENT_LINK_KEY_REQ - 1);
+	bit_set(filter.event_mask, NG_HCI_EVENT_LINK_KEY_NOTIFICATION - 1);
+
+	if (setsockopt(sock, SOL_HCI_RAW, SO_HCI_RAW_FILTER,
+			(void * const) &filter, sizeof(filter)) < 0)
+		err(1, "Could not set HCI socket filter");
+
+	if (detach && daemon(0, 0) < 0)
+		err(1, "Could not daemon()ize");
+
+	openlog(HCSECD_IDENT, LOG_NDELAY|LOG_PERROR|LOG_PID, LOG_DAEMON);
+
+	read_config_file();
+	read_keys_file();
+
+	if (detach) {
+		FILE	*pid = NULL;
+
+		if ((pid = fopen(HCSECD_PIDFILE, "w")) == NULL) {
+			syslog(LOG_ERR, "Could not create PID file %s. %s (%d)",
+					HCSECD_PIDFILE, strerror(errno), errno);
+			exit(1);
+		}
+
+		fprintf(pid, "%d", getpid());
+		fclose(pid);
+	}
+
+	event = (ng_hci_event_pkt_t *) buffer;
+	while (!done) {
+		size = sizeof(addr);
+		n = recvfrom(sock, buffer, sizeof(buffer), 0,
+				(struct sockaddr *) &addr, &size);
+		if (n < 0) {
+			if (errno == EINTR)
+				continue;
+
+			syslog(LOG_ERR, "Could not receive from HCI socket. " \
+					"%s (%d)", strerror(errno), errno);
+			exit(1);
+		}
+
+		if (event->type != NG_HCI_EVENT_PKT) {
+			syslog(LOG_ERR, "Received unexpected HCI packet, " \
+					"type=%#x", event->type);
+			continue;
+		}
+
+		switch (event->event) {
+		case NG_HCI_EVENT_PIN_CODE_REQ:
+			process_pin_code_request_event(sock, &addr,
+							(bdaddr_p)(event + 1));
+			break;
+
+		case NG_HCI_EVENT_LINK_KEY_REQ:
+			process_link_key_request_event(sock, &addr,
+							(bdaddr_p)(event + 1));
+			break;
+
+		case NG_HCI_EVENT_LINK_KEY_NOTIFICATION:
+			process_link_key_notification_event(sock, &addr,
+				(ng_hci_link_key_notification_ep *)(event + 1));
+			break;
+
+		default:
+			syslog(LOG_ERR, "Received unexpected HCI event, " \
+					"event=%#x", event->event);
+			break;
+		}
+	}
+
+	if (detach)
+		if (remove(HCSECD_PIDFILE) < 0)
+			syslog(LOG_ERR, "Could not remove PID file %s. %s (%d)",
+					HCSECD_PIDFILE, strerror(errno), errno);
+
+	dump_keys_file();
+	clean_config();
+	closelog();
+	close(sock);
+
+	return (0);
+}
+
+/* Process PIN_Code_Request event */
+static int
+process_pin_code_request_event(int sock, struct sockaddr_hci *addr,
+		bdaddr_p bdaddr)
+{
+	link_key_p	key = NULL;
+
+	syslog(LOG_DEBUG, "Got PIN_Code_Request event from '%s', " \
+			"remote bdaddr %s", addr->hci_node,
+			bt_ntoa(bdaddr, NULL));
+
+	if ((key = get_key(bdaddr, 0)) != NULL) {
+		syslog(LOG_DEBUG, "Found matching entry, " \
+				"remote bdaddr %s, name '%s', PIN code %s",
+				bt_ntoa(&key->bdaddr, NULL),
+				(key->name != NULL)? key->name : "No name",
+				(key->pin != NULL)? "exists" : "doesn't exist");
+
+		return (send_pin_code_reply(sock, addr, bdaddr, key->pin));
+	}
+
+	syslog(LOG_DEBUG, "Could not PIN code for remote bdaddr %s",
+			bt_ntoa(bdaddr, NULL));
+
+	return (send_pin_code_reply(sock, addr, bdaddr, NULL));
+}
+
+/* Process Link_Key_Request event */
+static int
+process_link_key_request_event(int sock, struct sockaddr_hci *addr,
+		bdaddr_p bdaddr)
+{
+	link_key_p	key = NULL;
+
+	syslog(LOG_DEBUG, "Got Link_Key_Request event from '%s', " \
+			"remote bdaddr %s", addr->hci_node,
+			bt_ntoa(bdaddr, NULL));
+
+	if ((key = get_key(bdaddr, 0)) != NULL) {
+		syslog(LOG_DEBUG, "Found matching entry, " \
+				"remote bdaddr %s, name '%s', link key %s",
+				bt_ntoa(&key->bdaddr, NULL),
+				(key->name != NULL)? key->name : "No name",
+				(key->key != NULL)? "exists" : "doesn't exist");
+
+		return (send_link_key_reply(sock, addr, bdaddr, key->key));
+	}
+
+	syslog(LOG_DEBUG, "Could not find link key for remote bdaddr %s",
+			bt_ntoa(bdaddr, NULL));
+
+	return (send_link_key_reply(sock, addr, bdaddr, NULL));
+}
+
+/* Send PIN_Code_[Negative]_Reply */
+static int
+send_pin_code_reply(int sock, struct sockaddr_hci *addr, 
+		bdaddr_p bdaddr, char const *pin)
+{
+	uint8_t			 buffer[HCSECD_BUFFER_SIZE];
+	ng_hci_cmd_pkt_t	*cmd = NULL;
+
+	memset(buffer, 0, sizeof(buffer));
+
+	cmd = (ng_hci_cmd_pkt_t *) buffer;
+	cmd->type = NG_HCI_CMD_PKT;
+
+	if (pin != NULL) {
+		ng_hci_pin_code_rep_cp	*cp = NULL;
+
+		cmd->opcode = htole16(NG_HCI_OPCODE(NG_HCI_OGF_LINK_CONTROL,
+						NG_HCI_OCF_PIN_CODE_REP));
+		cmd->length = sizeof(*cp);
+
+		cp = (ng_hci_pin_code_rep_cp *)(cmd + 1);
+		memcpy(&cp->bdaddr, bdaddr, sizeof(cp->bdaddr));
+		strncpy((char *) cp->pin, pin, sizeof(cp->pin));
+		cp->pin_size = strlen((char const *) cp->pin);
+
+		syslog(LOG_DEBUG, "Sending PIN_Code_Reply to '%s' " \
+				"for remote bdaddr %s",
+				addr->hci_node, bt_ntoa(bdaddr, NULL));
+	} else {
+		ng_hci_pin_code_neg_rep_cp	*cp = NULL;
+
+		cmd->opcode = htole16(NG_HCI_OPCODE(NG_HCI_OGF_LINK_CONTROL,
+						NG_HCI_OCF_PIN_CODE_NEG_REP));
+		cmd->length = sizeof(*cp);
+
+		cp = (ng_hci_pin_code_neg_rep_cp *)(cmd + 1);
+		memcpy(&cp->bdaddr, bdaddr, sizeof(cp->bdaddr));
+
+		syslog(LOG_DEBUG, "Sending PIN_Code_Negative_Reply to '%s' " \
+				"for remote bdaddr %s",
+				addr->hci_node, bt_ntoa(bdaddr, NULL));
+	}
+
+again:
+	if (sendto(sock, buffer, sizeof(*cmd) + cmd->length, 0,
+			(struct sockaddr *) addr, sizeof(*addr)) < 0) {
+		if (errno == EINTR)
+			goto again;
+
+		syslog(LOG_ERR, "Could not send PIN code reply to '%s' " \
+				"for remote bdaddr %s. %s (%d)",
+				addr->hci_node, bt_ntoa(bdaddr, NULL),
+				strerror(errno), errno);
+		return (-1);
+	}
+
+	return (0);
+}
+
+/* Send Link_Key_[Negative]_Reply */
+static int
+send_link_key_reply(int sock, struct sockaddr_hci *addr, 
+		bdaddr_p bdaddr, uint8_t *key)
+{
+	uint8_t			 buffer[HCSECD_BUFFER_SIZE];
+	ng_hci_cmd_pkt_t	*cmd = NULL;
+
+	memset(buffer, 0, sizeof(buffer));
+
+	cmd = (ng_hci_cmd_pkt_t *) buffer;
+	cmd->type = NG_HCI_CMD_PKT;
+
+	if (key != NULL) {
+		ng_hci_link_key_rep_cp	*cp = NULL;
+
+		cmd->opcode = htole16(NG_HCI_OPCODE(NG_HCI_OGF_LINK_CONTROL,
+						NG_HCI_OCF_LINK_KEY_REP));
+		cmd->length = sizeof(*cp);
+
+		cp = (ng_hci_link_key_rep_cp *)(cmd + 1);
+		memcpy(&cp->bdaddr, bdaddr, sizeof(cp->bdaddr));
+		memcpy(&cp->key, key, sizeof(cp->key));
+
+		syslog(LOG_DEBUG, "Sending Link_Key_Reply to '%s' " \
+				"for remote bdaddr %s",
+				addr->hci_node, bt_ntoa(bdaddr, NULL));
+	} else {
+		ng_hci_link_key_neg_rep_cp	*cp = NULL;
+
+		cmd->opcode = htole16(NG_HCI_OPCODE(NG_HCI_OGF_LINK_CONTROL,
+						NG_HCI_OCF_LINK_KEY_NEG_REP));
+		cmd->length = sizeof(*cp);
+
+		cp = (ng_hci_link_key_neg_rep_cp *)(cmd + 1);
+		memcpy(&cp->bdaddr, bdaddr, sizeof(cp->bdaddr));
+
+		syslog(LOG_DEBUG, "Sending Link_Key_Negative_Reply to '%s' " \
+				"for remote bdaddr %s",
+				addr->hci_node, bt_ntoa(bdaddr, NULL));
+	}
+
+again:
+	if (sendto(sock, buffer, sizeof(*cmd) + cmd->length, 0,
+			(struct sockaddr *) addr, sizeof(*addr)) < 0) {
+		if (errno == EINTR)
+			goto again;
+
+		syslog(LOG_ERR, "Could not send link key reply to '%s' " \
+				"for remote bdaddr %s. %s (%d)",
+				addr->hci_node, bt_ntoa(bdaddr, NULL),
+				strerror(errno), errno);
+		return (-1);
+	}
+
+	return (0);
+}
+
+/* Process Link_Key_Notification event */
+static int
+process_link_key_notification_event(int sock, struct sockaddr_hci *addr,
+		ng_hci_link_key_notification_ep *ep)
+{
+	link_key_p	key = NULL;
+
+	syslog(LOG_DEBUG, "Got Link_Key_Notification event from '%s', " \
+			"remote bdaddr %s", addr->hci_node,
+			bt_ntoa(&ep->bdaddr, NULL));
+
+	if ((key = get_key(&ep->bdaddr, 1)) == NULL) {
+		syslog(LOG_ERR, "Could not find entry for remote bdaddr %s",
+				bt_ntoa(&ep->bdaddr, NULL));
+		return (-1);
+	}
+
+	syslog(LOG_DEBUG, "Updating link key for the entry, " \
+			"remote bdaddr %s, name '%s', link key %s",
+			bt_ntoa(&key->bdaddr, NULL),
+			(key->name != NULL)? key->name : "No name",
+			(key->key != NULL)? "exists" : "doesn't exist");
+
+	if (key->key == NULL) {
+		key->key = (uint8_t *) malloc(NG_HCI_KEY_SIZE);
+		if (key->key == NULL) {
+			syslog(LOG_ERR, "Could not allocate link key");
+			exit(1);
+		}
+	}
+
+	memcpy(key->key, &ep->key, NG_HCI_KEY_SIZE);
+
+	return (0);
+}
+
+/* Signal handlers */
+static void
+sighup(int s)
+{
+	syslog(LOG_DEBUG, "Got SIGHUP (%d)", s);
+
+	dump_keys_file();
+	read_config_file();
+	read_keys_file();
+}
+
+static void
+sigint(int s)
+{
+	syslog(LOG_DEBUG, "Got signal %d, total number of signals %d",
+			s, ++ done);
+}
+
+/* Display usage and exit */
+static void
+usage(void)
+{
+	fprintf(stderr,
+"Usage: %s [-d] -f config_file [-h]\n" \
+"Where:\n" \
+"\t-d              do not detach from terminal\n" \
+"\t-f config_file  use <config_file>\n" \
+"\t-h              display this message\n", HCSECD_IDENT);
+
+	exit(255);
+}
+
diff --git a/etc/bluetooth/bthcid.conf b/usr.sbin/hcsecd/hcsecd.conf
similarity index 63%
rename from etc/bluetooth/bthcid.conf
rename to usr.sbin/hcsecd/hcsecd.conf
index 0aaf4c5fa4..dd895f4731 100644
--- a/etc/bluetooth/bthcid.conf
+++ b/usr.sbin/hcsecd/hcsecd.conf
@@ -1,5 +1,6 @@
-# $FreeBSD: src/usr.sbin/bluetooth/hcsecd/hcsecd.conf,v 1.1 2003/05/10 21:50:35 julian Exp $
-# $DragonFly: src/etc/bluetooth/bthcid.conf,v 1.1 2008/01/30 14:10:19 hasso Exp $
+#
+# $Id: hcsecd.conf,v 1.1 2002/11/24 20:22:39 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/hcsecd/hcsecd.conf 114879 2003-05-10 21:50:37Z julian $
 #
 # HCI security daemon configuration file
 #
@@ -40,24 +41,24 @@ device {
 	pin	nopin;
 }
 
-# device {
-# 	bdaddr	00:80:37:5e:4d:d4;
-# 	name	"Ericsson T68 phone";
-# 	key	nokey;
-# 	pin	"0000"; # PIN code (string up to 16 character)
-# }
-# 
-# device {
-# 	bdaddr	00:01:03:fc:6e:ec;
-# 	name	"3COM PCCARD";
-# 	key	nokey;
-# 	pin	"0000";
-# }
-# 
-# device {
-# 	bdaddr	00:11:22:33:44:55;
-# 	name	"Dummy";
-# 	key	0x00112233445566778899aabbccddeeff; # 16 bytes key (hex string)
-# 	pin	nopin;
-# }
+device {
+	bdaddr	00:80:37:5e:4d:d4;
+	name	"Ericsson T68 phone";
+	key	nokey;
+	pin	"0000"; # PIN code (string up to 16 character)
+}
+
+device {
+	bdaddr	00:01:03:fc:6e:ec;
+	name	"3COM PCCARD";
+	key	nokey;
+	pin	"0000";
+}
+
+device {
+	bdaddr	00:11:22:33:44:55;
+	name	"Dummy";
+	key	0x00112233445566778899aabbccddeeff; # 16 bytes key (hex string)
+	pin	nopin;
+}
 
diff --git a/usr.sbin/hcsecd/hcsecd.h b/usr.sbin/hcsecd/hcsecd.h
new file mode 100644
index 0000000000..886684813d
--- /dev/null
+++ b/usr.sbin/hcsecd/hcsecd.h
@@ -0,0 +1,65 @@
+/*
+ * hcsecd.h
+ *
+ * Copyright (c) 2001-2002 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: hcsecd.h,v 1.3 2003/09/08 18:54:21 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/hcsecd/hcsecd.h 128079 2004-04-09 23:58:53Z emax $
+ */
+
+#ifndef _HCSECD_H_
+#define _HCSECD_H_ 1
+
+#define HCSECD_BUFFER_SIZE	512
+#define HCSECD_IDENT		"hcsecd"
+#define HCSECD_PIDFILE		"/var/run/" HCSECD_IDENT ".pid"
+#define HCSECD_KEYSFILE		"/var/db/"  HCSECD_IDENT ".keys"
+
+struct link_key
+{
+	bdaddr_t		 bdaddr; /* remote device BDADDR */
+	char			*name;   /* remote device name */
+	uint8_t			*key;    /* link key (or NULL if no key) */
+	char			*pin;    /* pin (or NULL if no pin) */
+	LIST_ENTRY(link_key)	 next;   /* link to the next */
+};
+typedef struct link_key		link_key_t;
+typedef struct link_key *	link_key_p;
+
+extern char	*config_file;
+
+#if __config_debug__
+void		dump_config	(void);
+#endif
+
+void		read_config_file(void);
+void		clean_config	(void);
+link_key_p	get_key		(bdaddr_p bdaddr, int exact_match);
+
+int		read_keys_file  (void);
+int		dump_keys_file  (void);
+
+#endif /* ndef _HCSECD_H_ */
+
diff --git a/usr.sbin/bthcid/lexer.l b/usr.sbin/hcsecd/lexer.l
similarity index 94%
rename from usr.sbin/bthcid/lexer.l
rename to usr.sbin/hcsecd/lexer.l
index 11f3a48c8f..7d50a93194 100644
--- a/usr.sbin/bthcid/lexer.l
+++ b/usr.sbin/hcsecd/lexer.l
@@ -27,16 +27,14 @@
  * SUCH DAMAGE.
  *
  * $Id: lexer.l,v 1.1 2002/11/24 20:22:39 max Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/hcsecd/lexer.l,v 1.1 2003/05/10 21:50:35 julian Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/hcsecd/lexer.l 215676 2010-11-22 14:16:22Z brucec $
  */
 
 #include <string.h>
 #include "parser.h"
-
 %}
 
-%option yylineno noyywrap nounput
-%option noinput
+%option yylineno noyywrap nounput noinput
 
 delim		[ \t\n]
 ws		{delim}+
diff --git a/usr.sbin/bthcid/parser.y b/usr.sbin/hcsecd/parser.y
similarity index 71%
rename from usr.sbin/bthcid/parser.y
rename to usr.sbin/hcsecd/parser.y
index e51f5f882e..031ef2ed53 100644
--- a/usr.sbin/bthcid/parser.y
+++ b/usr.sbin/hcsecd/parser.y
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  *
  * $Id: parser.y,v 1.5 2003/06/07 21:22:30 max Exp $
- * $FreeBSD: src/usr.sbin/bluetooth/hcsecd/parser.y,v 1.4 2004/09/14 20:04:33 emax Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/hcsecd/parser.y 235789 2012-05-22 16:33:10Z bapt $
  */
 
 #include <sys/fcntl.h>
@@ -36,26 +36,24 @@
 #include <errno.h>
 #include <limits.h>
 #include <stdio.h>
-#include <stdarg.h>
 #include <stdlib.h>
+#include <stdarg.h>
 #include <string.h>
 #include <syslog.h>
 #include <unistd.h>
-#include "bthcid.h"
+#include "hcsecd.h"
 
+	int	yyparse  (void);
 	int	yylex    (void);
 
 static	void	free_key (link_key_p key);
 static	int	hexa2int4(char *a);
 static	int	hexa2int8(char *a);
 
-extern	void			 yyerror(const char *);
 extern	int			 yylineno;
-extern	FILE			*yyin;
-
 static	LIST_HEAD(, link_key)	 link_keys;
+	char			*config_file = "/etc/bluetooth/hcsecd.conf";
 
-const	char			*config_file = "/etc/bluetooth/bthcid.conf";
 static	link_key_p		 key = NULL;
 %}
 
@@ -110,7 +108,7 @@ option:		bdaddr
 bdaddr:		T_BDADDR T_BDADDRSTRING
 			{
 			if (!bt_aton($2, &key->bdaddr)) {
-				syslog(LOG_ERR, "Could not parse BD_ADDR " \
+				syslog(LOG_ERR, "Cound not parse BD_ADDR " \
 						"'%s'", $2);
 				exit(1);
 			}
@@ -138,18 +136,18 @@ key:		T_KEY T_HEXSTRING
 			if (key->key != NULL)
 				free(key->key);
 
-			key->key = (uint8_t *) malloc(HCI_KEY_SIZE);
+			key->key = (uint8_t *) malloc(NG_HCI_KEY_SIZE);
 			if (key->key == NULL) {
 				syslog(LOG_ERR, "Could not allocate new " \
 						"link key");
 				exit(1);
 			}
 
-			memset(key->key, 0, HCI_KEY_SIZE);
+			memset(key->key, 0, NG_HCI_KEY_SIZE);
 
 			len = strlen($2) / 2;
-			if (len > HCI_KEY_SIZE)
-				len = HCI_KEY_SIZE;
+			if (len > NG_HCI_KEY_SIZE)
+				len = NG_HCI_KEY_SIZE;
 
 			for (i = 0; i < len; i ++)
 				key->key[i] = hexa2int8((char *)($2) + 2*i);
@@ -197,6 +195,8 @@ yyerror(char const *message)
 void
 read_config_file(void)
 {
+	extern FILE	*yyin;
+
 	if (config_file == NULL) {
 		syslog(LOG_ERR, "Unknown config file name!");
 		exit(1);
@@ -226,11 +226,11 @@ read_config_file(void)
 void
 clean_config(void)
 {
-	link_key_p	lkey = NULL;
+	link_key_p	key = NULL;
 
-	while ((lkey = LIST_FIRST(&link_keys)) != NULL) {
-		LIST_REMOVE(lkey, next);
-		free_key(lkey);
+	while ((key = LIST_FIRST(&link_keys)) != NULL) {
+		LIST_REMOVE(key, next);
+		free_key(key);
 	}
 }
 
@@ -238,19 +238,19 @@ clean_config(void)
 link_key_p
 get_key(bdaddr_p bdaddr, int exact_match)
 {
-	link_key_p	lkey = NULL, defkey = NULL;
+	link_key_p	key = NULL, defkey = NULL;
 
-	LIST_FOREACH(lkey, &link_keys, next) {
-		if (memcmp(bdaddr, &lkey->bdaddr, sizeof(lkey->bdaddr)) == 0)
+	LIST_FOREACH(key, &link_keys, next) {
+		if (memcmp(bdaddr, &key->bdaddr, sizeof(key->bdaddr)) == 0)
 			break;
 
 		if (!exact_match)
-			if (memcmp(BDADDR_ANY, &lkey->bdaddr,
-					sizeof(lkey->bdaddr)) == 0)
-				defkey = lkey;
+			if (memcmp(NG_HCI_BDADDR_ANY, &key->bdaddr,
+					sizeof(key->bdaddr)) == 0)
+				defkey = key;
 	}
 
-	return ((lkey != NULL)? lkey : defkey);
+	return ((key != NULL)? key : defkey);
 }
 
 #ifdef __config_debug__
@@ -258,29 +258,29 @@ get_key(bdaddr_p bdaddr, int exact_match)
 void
 dump_config(void)
 {
-	link_key_p	lkey = NULL;
+	link_key_p	key = NULL;
 	char		buffer[64];
 
-	LIST_FOREACH(lkey, &link_keys, next) {
-		if (lkey->key != NULL)
+	LIST_FOREACH(key, &link_keys, next) {
+		if (key->key != NULL)
 			snprintf(buffer, sizeof(buffer),
 "0x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
-				lkey->key[0], lkey->key[1], lkey->key[2],
-				lkey->key[3], lkey->key[4], lkey->key[5],
-				lkey->key[6], lkey->key[7], lkey->key[8],
-				lkey->key[9], lkey->key[10], lkey->key[11],
-				lkey->key[12], lkey->key[13], lkey->key[14],
-				lkey->key[15]);
+				key->key[0], key->key[1], key->key[2],
+				key->key[3], key->key[4], key->key[5],
+				key->key[6], key->key[7], key->key[8],
+				key->key[9], key->key[10], key->key[11],
+				key->key[12], key->key[13], key->key[14],
+				key->key[15]);
 
 		syslog(LOG_DEBUG, 
 "device %s " \
 "bdaddr %s " \
 "pin %s " \
 "key %s",
-			(lkey->name != NULL)? lkey->name : "noname",
-			bt_ntoa(&lkey->bdaddr, NULL),
-			(lkey->pin != NULL)? lkey->pin : "nopin",
-			(lkey->key != NULL)? buffer : "nokey");
+			(key->name != NULL)? key->name : "noname",
+			bt_ntoa(&key->bdaddr, NULL),
+			(key->pin != NULL)? key->pin : "nopin",
+			(key->key != NULL)? buffer : "nokey");
 	}
 }
 #endif
@@ -290,17 +290,17 @@ int
 read_keys_file(void)
 {
 	FILE		*f = NULL;
-	link_key_t	*lkey = NULL;
-	char		 buf[BTHCID_BUFFER_SIZE], *p = NULL, *cp = NULL;
+	link_key_t	*key = NULL;
+	char		 buf[HCSECD_BUFFER_SIZE], *p = NULL, *cp = NULL;
 	bdaddr_t	 bdaddr;
 	int		 i, len;
 
-	if ((f = fopen(BTHCID_KEYSFILE, "r")) == NULL) {
+	if ((f = fopen(HCSECD_KEYSFILE, "r")) == NULL) {
 		if (errno == ENOENT)
 			return (0);
 
 		syslog(LOG_ERR, "Could not open keys file %s. %s (%d)\n",
-				BTHCID_KEYSFILE, strerror(errno), errno);
+				HCSECD_KEYSFILE, strerror(errno), errno);
 
 		return (-1);
 	}
@@ -316,30 +316,30 @@ read_keys_file(void)
 		if (!bt_aton(p, &bdaddr))
 			continue;
 
-		if ((lkey = get_key(&bdaddr, 1)) == NULL)
+		if ((key = get_key(&bdaddr, 1)) == NULL)
 			continue;
 
-		if (lkey->key == NULL) {
-			lkey->key = (uint8_t *) malloc(HCI_KEY_SIZE);
-			if (lkey->key == NULL) {
+		if (key->key == NULL) {
+			key->key = (uint8_t *) malloc(NG_HCI_KEY_SIZE);
+			if (key->key == NULL) {
 				syslog(LOG_ERR, "Could not allocate link key");
 				exit(1);
 			}
 		}
 
-		memset(lkey->key, 0, HCI_KEY_SIZE);
+		memset(key->key, 0, NG_HCI_KEY_SIZE);
 
 		len = strlen(cp) / 2;
-		if (len > HCI_KEY_SIZE)
-			len = HCI_KEY_SIZE;
+		if (len > NG_HCI_KEY_SIZE)
+			len = NG_HCI_KEY_SIZE;
 
 		for (i = 0; i < len; i ++)
-			lkey->key[i] = hexa2int8(cp + 2*i);
+			key->key[i] = hexa2int8(cp + 2*i);
 
 		syslog(LOG_DEBUG, "Restored link key for the entry, " \
 				"remote bdaddr %s, name '%s'",
-				bt_ntoa(&lkey->bdaddr, NULL),
-				(lkey->name != NULL)? lkey->name : "No name");
+				bt_ntoa(&key->bdaddr, NULL),
+				(key->name != NULL)? key->name : "No name");
 	}
 
 	fclose(f);
@@ -351,28 +351,28 @@ read_keys_file(void)
 int
 dump_keys_file(void)
 {
-	link_key_p	lkey = NULL;
-	char		tmp[PATH_MAX], buf[BTHCID_BUFFER_SIZE];
+	link_key_p	key = NULL;
+	char		tmp[PATH_MAX], buf[HCSECD_BUFFER_SIZE];
 	int		f;
 
-	snprintf(tmp, sizeof(tmp), "%s.tmp", BTHCID_KEYSFILE);
+	snprintf(tmp, sizeof(tmp), "%s.tmp", HCSECD_KEYSFILE);
 	if ((f = open(tmp, O_RDWR|O_CREAT|O_TRUNC|O_EXCL, 0600)) < 0) {
 		syslog(LOG_ERR, "Could not create temp keys file %s. %s (%d)\n",
 				tmp, strerror(errno), errno);
 		return (-1);
 	}
 
-	LIST_FOREACH(lkey, &link_keys, next) {
-		if (lkey->key == NULL)
+	LIST_FOREACH(key, &link_keys, next) {
+		if (key->key == NULL)
 			continue;
 
 		snprintf(buf, sizeof(buf),
 "%s %02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n",
-			bt_ntoa(&lkey->bdaddr, NULL),
-			lkey->key[0],  lkey->key[1],  lkey->key[2],  lkey->key[3],
-			lkey->key[4],  lkey->key[5],  lkey->key[6],  lkey->key[7],
-			lkey->key[8],  lkey->key[9],  lkey->key[10], lkey->key[11],
-			lkey->key[12], lkey->key[13], lkey->key[14], lkey->key[15]);
+			bt_ntoa(&key->bdaddr, NULL),
+			key->key[0],  key->key[1],  key->key[2],  key->key[3],
+			key->key[4],  key->key[5],  key->key[6],  key->key[7],
+			key->key[8],  key->key[9],  key->key[10], key->key[11],
+			key->key[12], key->key[13], key->key[14], key->key[15]);
 
 		if (write(f, buf, strlen(buf)) < 0) {
 			syslog(LOG_ERR, "Could not write temp keys file. " \
@@ -383,9 +383,9 @@ dump_keys_file(void)
 
 	close(f);
 
-	if (rename(tmp, BTHCID_KEYSFILE) < 0) {
+	if (rename(tmp, HCSECD_KEYSFILE) < 0) {
 		syslog(LOG_ERR, "Could not rename(%s, %s). %s (%d)\n",
-				tmp, BTHCID_KEYSFILE, strerror(errno), errno);
+				tmp, HCSECD_KEYSFILE, strerror(errno), errno);
 		unlink(tmp);
 		return (-1);
 	}
@@ -395,17 +395,17 @@ dump_keys_file(void)
 
 /* Free key entry */
 static void
-free_key(link_key_p lkey)
+free_key(link_key_p key)
 {
-	if (lkey->name != NULL)
-		free(lkey->name);
-	if (lkey->key != NULL)
-		free(lkey->key);
-	if (lkey->pin != NULL)
-		free(lkey->pin);
-
-	memset(lkey, 0, sizeof(*lkey));
-	free(lkey);
+	if (key->name != NULL)
+		free(key->name);
+	if (key->key != NULL)
+		free(key->key);
+	if (key->pin != NULL)
+		free(key->pin);
+
+	memset(key, 0, sizeof(*key));
+	free(key);
 }
 
 /* Convert hex ASCII to int4 */
diff --git a/usr.sbin/hcseriald/Makefile b/usr.sbin/hcseriald/Makefile
new file mode 100644
index 0000000000..295f85f2da
--- /dev/null
+++ b/usr.sbin/hcseriald/Makefile
@@ -0,0 +1,11 @@
+# $Id: Makefile,v 1.5 2003/08/14 20:06:21 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/hcseriald/Makefile 140941 2005-01-28 16:08:11Z ru $
+
+PROG=		hcseriald
+MAN=		hcseriald.8
+WARNS?=		2
+
+DPADD=		${LIBNETGRAPH}
+LDADD=		-lnetgraph
+
+.include <bsd.prog.mk>
